Index: plugins/simpleMenu/index.php
===================================================================
--- plugins/simpleMenu/index.php	(revision 1011)
+++ plugins/simpleMenu/index.php	(revision 790)
@@ -412,14 +412,14 @@
 
 if (!empty($_GET['added'])) {
-	dcPage::message(__('Menu item has been successfully added.'));
+	echo '<p class="message">'.__('Menu item has been successfully added.').'</p>';
 }
 if (!empty($_GET['removed'])) {
-	dcPage::message(__('Menu items have been successfully removed.'));
+	echo '<p class="message">'.__('Menu items have been successfully removed.').'</p>';
 }
 if (!empty($_GET['neworder'])) {
-	dcPage::message(__('Menu items have been successfully updated.'));
+	echo '<p class="message">'.__('Menu items have been successfully updated.').'</p>';
 }
 if (!empty($_GET['updated'])) {
-	dcPage::message(__('Menu items have been successfully updated.'));
+	echo '<p class="message">'.__('Menu items have been successfully updated.').'</p>';
 }
 
@@ -434,5 +434,5 @@
 			echo '<form id="additem" action="'.$p_url.'&add=2" method="post">';
 			echo '<fieldset><legend>'.__('Select type').'</legend>';
-			echo '<p class="field"><label for="item_type" class="classic">'.__('Type of item menu:').'</label>'.form::combo('item_type',$items_combo,'').'</p>';
+			echo '<p class="field"><label for"item_type" class="classic">'.__('Type of item menu:').'</label>'.form::combo('item_type',$items_combo,'').'</p>';
 			echo '<p>'.$core->formNonce().'<input type="submit" name="appendaction" value="'.__('Continue...').'" />'.'</p>';
 			echo '</fieldset>';
@@ -446,21 +446,21 @@
 				switch ($item_type) {
 					case 'lang':
-						echo '<p class="field"><label for="item_select" class="classic">'.__('Select language:').'</label>'.
+						echo '<p class="field"><label for"item_select" class="classic">'.__('Select language:').'</label>'.
 							form::combo('item_select',$langs_combo,'');
 						break;
 					case 'category':
-						echo '<p class="field"><label for="item_select" class="classic">'.__('Select category:').'</label>'.
+						echo '<p class="field"><label for"item_select" class="classic">'.__('Select category:').'</label>'.
 							form::combo('item_select',$categories_combo,'');
 						break;
 					case 'archive':
-						echo '<p class="field"><label for="item_select" class="classic">'.__('Select month (if necessary):').'</label>'.
+						echo '<p class="field"><label for"item_select" class="classic">'.__('Select month (if necessary):').'</label>'.
 							form::combo('item_select',$months_combo,'');
 						break;
 					case 'pages':
-						echo '<p class="field"><label for="item_select" class="classic">'.__('Select page:').'</label>'.
+						echo '<p class="field"><label for"item_select" class="classic">'.__('Select page:').'</label>'.
 							form::combo('item_select',$pages_combo,'');
 						break;
 					case 'tags':
-						echo '<p class="field"><label for="item_select" class="classic">'.__('Select tag (if necessary):').'</label>'.
+						echo '<p class="field"><label for"item_select" class="classic">'.__('Select tag (if necessary):').'</label>'.
 							form::combo('item_select',$tags_combo,'');
 						break;
@@ -481,9 +481,9 @@
 			echo '<form id="additem" action="'.$p_url.'&add=4" method="post">';
 			echo '<fieldset><legend>'.$item_type_label.($item_select_label != '' ? ' ('.$item_select_label.')' : '').'</legend>';
-			echo '<p class="field"><label for="item_label" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.
+			echo '<p class="field"><label for"item_label" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.
 				__('Label of item menu:').'</label>'.form::field('item_label',20,255,$item_label).'</p>';
-			echo '<p class="field"><label for="item_descr" class="classic">'.
+			echo '<p class="field"><label for"item_descr" class="classic">'.
 				__('Description of item menu:').'</label>'.form::field('item_descr',30,255,$item_descr).'</p>';
-			echo '<p class="field"><label for="item_url" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.
+			echo '<p class="field"><label for"item_url" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.
 				__('URL of item menu:').'</label>'.form::field('item_url',40,255,$item_url).'</p>';
 			echo form::hidden('item_type',$item_type).form::hidden('item_select',$item_select);
Index: plugins/tags/_admin.php
===================================================================
--- plugins/tags/_admin.php	(revision 897)
+++ plugins/tags/_admin.php	(revision 818)
@@ -31,7 +31,6 @@
 
 $core->addBehavior('adminPreferencesForm',array('tagsBehaviors','adminUserForm'));
-$core->addBehavior('adminBeforeUserOptionsUpdate',array('tagsBehaviors','setTagListFormat'));
-
-$core->addBehavior('adminUserForm',array('tagsBehaviors','adminUserForm'));
+// $core->addBehavior('adminUserForm',array('tagsBehaviors','adminUserForm'));
+
 $core->addBehavior('adminBeforeUserCreate',array('tagsBehaviors','setTagListFormat'));
 $core->addBehavior('adminBeforeUserUpdate',array('tagsBehaviors','setTagListFormat'));
Index: plugins/tags/_define.php
===================================================================
--- plugins/tags/_define.php	(revision 965)
+++ plugins/tags/_define.php	(revision 464)
@@ -16,5 +16,5 @@
 	/* Description*/		"Tags for posts",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.2',
+	/* Version */			'1.1',
 	array(
 		'permissions' =>	'usage,contentadmin'
Index: plugins/tags/_public.php
===================================================================
--- plugins/tags/_public.php	(revision 945)
+++ plugins/tags/_public.php	(revision 816)
@@ -23,7 +23,5 @@
 $core->tpl->addBlock('TagsFooter',array('tplTags','TagsFooter'));
 $core->tpl->addBlock('EntryTags',array('tplTags','EntryTags'));
-$core->tpl->addBlock('TagIf',array('tplTags','TagIf'));
 $core->tpl->addValue('TagID',array('tplTags','TagID'));
-$core->tpl->addValue('TagCount',array('tplTags','TagCount'));
 $core->tpl->addValue('TagPercent',array('tplTags','TagPercent'));
 $core->tpl->addValue('TagRoundPercent',array('tplTags','TagRoundPercent'));
@@ -46,4 +44,5 @@
 
 $core->addBehavior('templateBeforeBlock',array('behaviorsTags','templateBeforeBlock'));
+$core->addBehavior('tplSysIfConditions',array('behaviorsTags','tplSysIfConditions'));
 $core->addBehavior('publicBeforeDocument',array('behaviorsTags','addTplPath'));
 
@@ -74,4 +73,16 @@
 	}
 	
+	public static function tplSysIfConditions($tag, $attr,$content,$if)
+	{
+		if ($tag == 'Sys' && isset($attr['has_tag'])) {
+			$sign = '';
+			if (substr($attr['has_tag'],0,1) == '!') {
+				$sign = '!';
+				$attr['has_tag'] = substr($attr['has_tag'],1);
+			}
+			$if[] =  $sign."(\$core->tpl->tagExists('".addslashes($attr['has_tag'])."') )";
+		}
+	}
+	
 	public static function addTplPath($core)
 	{
@@ -155,22 +166,5 @@
 		return $res;
 	}
-
-	public static function TagIf($attr,$content) 
-	{ 
-		$if = array();
-		$operateur = isset($attr['operator']) ? dcTemplate::getOperator($attr['operator']) : '&&';
-
-		if (isset($attr['has_entries'])) {
-			$sign = (boolean) $attr['has_entries'] ? '' : '!';
-			$if[] = $sign.'$_ctx->meta->count';
-		}
-
-		if (!empty($if)) {
-			return '<?php if('.implode(' '.$operateur.' ',$if).') : ?>'.$content.'<?php endif; ?>';
-		} else {
-			return $content;
-		}
-	}
-
+	
 	public static function TagID($attr)
 	{
@@ -179,9 +173,4 @@
 	}
 	
-	public static function TagCount($attr)
-	{
-		return '<?php echo $_ctx->meta->count; ?>';
-	}
-
 	public static function TagPercent($attr)
 	{
@@ -225,9 +214,4 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
-			return;
-		}
-
 		$params = array('meta_type' => 'tag');
 		
@@ -256,5 +240,5 @@
 		
 		$res =
-		'<div class="tags'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="tags">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -264,5 +248,5 @@
 			$res .=
 			'<li><a href="'.$core->blog->url.$core->url->getURLFor('tag',rawurlencode($rs->meta_id)).'" '.
-			'class="tag'.$rs->roundpercent.'">'.
+			'class="tag'.$rs->roundpercent.'" rel="tag">'.
 			$rs->meta_id.'</a> </li>';
 		}
Index: plugins/tags/_widgets.php
===================================================================
--- plugins/tags/_widgets.php	(revision 954)
+++ plugins/tags/_widgets.php	(revision 270)
@@ -19,5 +19,5 @@
 	public static function initWidgets($w)
 	{
-		$w->create('tags',__('Tags'),array('tplTags','tagsWidget'),null,'Tags cloud');
+		$w->create('tags',__('Tags'),array('tplTags','tagsWidget'));
 		$w->tags->setting('title',__('Title:'),__('Tags'));
 		$w->tags->setting('limit',__('Limit (empty means no limit):'),'20');
@@ -29,12 +29,4 @@
 		);
 		$w->tags->setting('alltagslinktitle',__('Link to all tags:'),__('All tags'));
-		$w->tags->setting('homeonly',__('Display on:'),0,'combo',
-			array(
-				__('All pages') => 0,
-				__('Home page only') => 1,
-				__('Except on home page') => 2
-				)
-		);
-		$w->tags->setting('class',__('CSS class:'),'');
 	}
 	
Index: plugins/tags/tag_posts.php
===================================================================
--- plugins/tags/tag_posts.php	(revision 907)
+++ plugins/tags/tag_posts.php	(revision 793)
@@ -114,5 +114,5 @@
 <?php
 if (!empty($_GET['renamed'])) {
-	dcPage::message(__('Tag has been successfully renamed'));
+	echo '<p class="message">'.__('Tag has been successfully renamed').'</p>';
 }
 
Index: plugins/tags/tags.php
===================================================================
--- plugins/tags/tags.php	(revision 907)
+++ plugins/tags/tags.php	(revision 711)
@@ -25,5 +25,5 @@
 <?php
 if (!empty($_GET['del'])) {
-	dcPage::message(__('Tag has been successfully removed'));
+	echo '<p class="message">'.__('Tag has been successfully removed').'</p>';
 }
 
Index: plugins/themeEditor/_admin.php
===================================================================
--- plugins/themeEditor/_admin.php	(revision 998)
+++ plugins/themeEditor/_admin.php	(revision 270)
@@ -16,47 +16,10 @@
 }
 
-$core->addBehavior('adminCurrentThemeDetails', array('themeEditorBehaviors','theme_editor_details'));
+$core->addBehavior('adminCurrentThemeDetails','theme_editor_details');
 
-$core->addBehavior('adminBeforeUserOptionsUpdate',array('themeEditorBehaviors','adminBeforeUserUpdate'));
-$core->addBehavior('adminPreferencesForm',array('themeEditorBehaviors','adminPreferencesForm'));
-
-class themeEditorBehaviors
+function theme_editor_details($core,$id)
 {
-	public static function theme_editor_details($core,$id)
-	{
-		if ($id != 'default' && $core->auth->isSuperAdmin()) {
-			return '<p><a href="plugin.php?p=themeEditor" class="button">'.__('Theme Editor').'</a></p>';
-		}
-	}
-
-	public static function adminBeforeUserUpdate($cur,$userID)
-	{
-		global $core;
-
-		// Get and store user's prefs for plugin options
-		$core->auth->user_prefs->addWorkspace('interface');
-		try {
-			$core->auth->user_prefs->interface->put('colorsyntax',!empty($_POST['colorsyntax']),'boolean');
-		} 
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
-	}
-	
-	public static function adminPreferencesForm($core)
-	{
-		// Add fieldset for plugin options
-		$core->auth->user_prefs->addWorkspace('interface');
-
-		echo
-		'<fieldset><legend>'.__('Theme Editor').'</legend>'.
-		
-		'<p><label for="colorsyntax" class="classic">'.
-		form::checkbox('colorsyntax',1,$core->auth->user_prefs->interface->colorsyntax).' '.
-		__('Syntax color').'</label></p>'.
-
-		'<br class="clear" />'. //Opera sucks
-		'</fieldset>';
+	if ($id != 'default' && $core->auth->isSuperAdmin()) {
+		return '<p><a href="plugin.php?p=themeEditor" class="button">'.__('Theme Editor').'</a></p>';
 	}
 }
Index: plugins/themeEditor/_define.php
===================================================================
--- plugins/themeEditor/_define.php	(revision 965)
+++ plugins/themeEditor/_define.php	(revision 464)
@@ -16,5 +16,5 @@
 	/* Description*/		"Theme Editor",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.0'
+	/* Version */			'0.9'
 );
 ?>
Index: plugins/themeEditor/index.php
===================================================================
--- plugins/themeEditor/index.php	(revision 997)
+++ plugins/themeEditor/index.php	(revision 500)
@@ -15,8 +15,4 @@
 
 $file_default = $file = array('c'=>null, 'w'=>false, 'type'=>null, 'f'=>null, 'default_file'=>false);
-
-# Get interface setting
-$core->auth->user_prefs->addWorkspace('interface');
-$user_ui_colorsyntax = $core->auth->user_prefs->interface->colorsyntax;
 
 # Loading themes
@@ -66,19 +62,7 @@
   <?php echo dcPage::jsVar('dotclear.msg.document_saved',__("Document saved")); ?>
   <?php echo dcPage::jsVar('dotclear.msg.error_occurred',__("An error occurred:")); ?>
-  <?php echo dcPage::jsVar('dotclear.colorsyntax',$user_ui_colorsyntax); ?>
   //]]>
   </script>
   <script type="text/javascript" src="index.php?pf=themeEditor/script.js"></script>
-<?php if ($user_ui_colorsyntax) { ?>
-  <link rel="stylesheet" type="text/css" href="index.php?pf=themeEditor/codemirror/codemirror.css" />
-  <link rel="stylesheet" type="text/css" href="index.php?pf=themeEditor/codemirror.css" />
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/codemirror.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/multiplex.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/xml.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/javascript.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/css.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/php.js"></script>
-  <script type="text/JavaScript" src="index.php?pf=themeEditor/codemirror/htmlmixed.js"></script>
-<?php } ?>
 </head>
 
@@ -124,32 +108,4 @@
 	echo
 	'</fieldset></form>';
-
-	if ($user_ui_colorsyntax) {
-		$editorMode = (!empty($_REQUEST['css']) ? "css" : (!empty($_REQUEST['js']) ? "javascript" : "text/html"));
-		echo 
-		'<script>
-			window.CodeMirror.defineMode("dotclear", function(config) {
-				return CodeMirror.multiplexingMode(
-					CodeMirror.getMode(config, "'.$editorMode.'"),
-					{open: "{{tpl:", close: "}}",
-					 mode: CodeMirror.getMode(config, "text/plain"),
-					 delimStyle: "delimit"},
-					{open: "<tpl:", close: ">",
-					 mode: CodeMirror.getMode(config, "text/plain"),
-					 delimStyle: "delimit"},
-					{open: "</tpl:", close: ">",
-					 mode: CodeMirror.getMode(config, "text/plain"),
-					 delimStyle: "delimit"}
-					);
-			});
-	    	var editor = CodeMirror.fromTextArea(document.getElementById("file_content"), {
-	    		mode: "dotclear",
-	       		tabMode: "indent",
-	       		lineWrapping: "true",
-	       		lineNumbers: "true",
-	   			matchBrackets: "true"
-	   		});
-	    </script>';
-	}
 }
 ?>
Index: plugins/themeEditor/script.js
===================================================================
--- plugins/themeEditor/script.js	(revision 948)
+++ plugins/themeEditor/script.js	(revision 0)
@@ -5,5 +5,5 @@
 		
 		var data = {
-			file_content: (!dotclear.colorsyntax ? $(f).find('#file_content').get(0).value : editor.getValue()),
+			file_content: $(f).find('#file_content').get(0).value,
 			xd_check: $(f).find('input[name="xd_check"]').get(0).value,
 			write: 1
Index: plugins/userPref/_define.php
===================================================================
--- plugins/userPref/_define.php	(revision 967)
+++ plugins/userPref/_define.php	(revision 589)
@@ -16,5 +16,5 @@
 	/* Description*/		"Manage every user preference directive",
 	/* Author */			"Franck Paul",
-	/* Version */			'0.3'
+	/* Version */			'0.2'
 );
 ?>
Index: plugins/userPref/index.php
===================================================================
--- plugins/userPref/index.php	(revision 907)
+++ plugins/userPref/index.php	(revision 589)
@@ -117,9 +117,9 @@
 <?php
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Preferences successfully updated'));
+	echo '<p class="message">'.__('Preferences successfully updated').'</p>';
 }
 
 if (!empty($_GET['upda'])) {
-	dcPage::message(__('Preferences definition successfully updated'));
+	echo '<p class="message">'.__('Preferences definition successfully updated').'</p>';
 }
 ?>
Index: plugins/widgets/_default_widgets.php
===================================================================
--- plugins/widgets/_default_widgets.php	(revision 954)
+++ plugins/widgets/_default_widgets.php	(revision 665)
@@ -18,59 +18,40 @@
 $__widgets = new dcWidgets;
 
-$__widgets->create('search',__('Search engine'),array('defaultWidgets','search'),null,'Search engine form');
+$__widgets->create('search',__('Search engine'),array('defaultWidgets','search'));
 $__widgets->search->setting('title',__('Title:'),__('Search'));
-$__widgets->search->setting('homeonly',__('Display on:'),0,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->search->setting('class',__('CSS class:'),'');
 
-$__widgets->create('navigation',__('Navigation links'),array('defaultWidgets','navigation'),null,'List of navigation links');
+$__widgets->create('navigation',__('Navigation links'),array('defaultWidgets','navigation'));
 $__widgets->navigation->setting('title',__('Title:'),'');
-$__widgets->navigation->setting('homeonly',__('Display on:'),0,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->navigation->setting('class',__('CSS class:'),'');
 
-$__widgets->create('bestof',__('Selected entries'),array('defaultWidgets','bestof'),null,'List of selected entries');
+$__widgets->create('bestof',__('Selected entries'),array('defaultWidgets','bestof'));
 $__widgets->bestof->setting('title',__('Title:'),__('Best of me'));
 $__widgets->bestof->setting('orderby',__('Sort:'),'asc','combo',array(__('Ascending') => 'asc', __('Descending') => 'desc'));
-$__widgets->bestof->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->bestof->setting('class',__('CSS class:'),'');
+$__widgets->bestof->setting('homeonly',__('Home page only'),1,'check');
 
-$__widgets->create('langs',__('Blog languages'),array('defaultWidgets','langs'),null,'List of available languages');
+$__widgets->create('langs',__('Blog languages'),array('defaultWidgets','langs'));
 $__widgets->langs->setting('title',__('Title:'),__('Languages'));
-$__widgets->langs->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->langs->setting('class',__('CSS class:'),'');
+$__widgets->langs->setting('homeonly',__('Home page only'),1,'check');
 
-$__widgets->create('categories',__('Categories list'),array('defaultWidgets','categories'),null,'List of categories');
+$__widgets->create('categories',__('Categories list'),array('defaultWidgets','categories'));
 $__widgets->categories->setting('title',__('Title:'),__('Categories'));
 $__widgets->categories->setting('postcount',__('With entries counts'),0,'check');
-$__widgets->categories->setting('homeonly',__('Display on:'),0,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->categories->setting('class',__('CSS class:'),'');
 
-$__widgets->create('subscribe',__('Subscribe links'),array('defaultWidgets','subscribe'),null,'RSS or Atom feed subscription links');
+$__widgets->create('subscribe',__('Subscribe links'),array('defaultWidgets','subscribe'));
 $__widgets->subscribe->setting('title',__('Title:'),__('Subscribe'));
 $__widgets->subscribe->setting('type',__('Feeds type:'),'atom','combo',array('Atom' => 'atom', 'RSS' => 'rss2'));
-$__widgets->subscribe->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->subscribe->setting('class',__('CSS class:'),'');
+$__widgets->subscribe->setting('homeonly',__('Home page only'),0,'check');
 
-$__widgets->create('feed',__('Feed reader'),array('defaultWidgets','feed'),null,'Last entries from feed');
+$__widgets->create('feed',__('Feed reader'),array('defaultWidgets','feed'));
 $__widgets->feed->setting('title',__('Title:'),__('Somewhere else'));
 $__widgets->feed->setting('url',__('Feed URL:'),'');
 $__widgets->feed->setting('limit',__('Entries limit:'),10);
-$__widgets->feed->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->feed->setting('class',__('CSS class:'),'');
+$__widgets->feed->setting('homeonly',__('Home page only'),1,'check');
 
-$__widgets->create('text',__('Text'),array('defaultWidgets','text'),null,'Simple text');
+$__widgets->create('text',__('Text'),array('defaultWidgets','text'));
 $__widgets->text->setting('title',__('Title:'),'');
 $__widgets->text->setting('text',__('Text:'),'','textarea');
-$__widgets->text->setting('homeonly',__('Display on:'),0,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->text->setting('class',__('CSS class:'),'');
+$__widgets->text->setting('homeonly',__('Home page only'),0,'check');
 
-$__widgets->create('lastposts',__('Last entries'),array('defaultWidgets','lastposts'),null,'List of last entries published');
+$__widgets->create('lastposts',__('Last entries'),array('defaultWidgets','lastposts'));
 $__widgets->lastposts->setting('title',__('Title:'),__('Last entries'));
 $rs = $core->blog->getCategories(array('post_type'=>'post'));
@@ -85,14 +66,11 @@
 }
 $__widgets->lastposts->setting('limit',__('Entries limit:'),10);
-$__widgets->lastposts->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->lastposts->setting('class',__('CSS class:'),'');
+$__widgets->lastposts->setting('homeonly',__('Home page only'),1,'check');
 
-$__widgets->create('lastcomments',__('Last comments'),array('defaultWidgets','lastcomments'),null,'List of last comments posted');
+
+$__widgets->create('lastcomments',__('Last comments'),array('defaultWidgets','lastcomments'));
 $__widgets->lastcomments->setting('title',__('Title:'),__('Last comments'));
 $__widgets->lastcomments->setting('limit',__('Comments limit:'),10);
-$__widgets->lastcomments->setting('homeonly',__('Display on:'),1,'combo',
-	array(__('All pages') => 0, __('Home page only') => 1, __('Except on home page') => 2));
-$__widgets->lastcomments->setting('class',__('CSS class:'),'');
+$__widgets->lastcomments->setting('homeonly',__('Home page only'),1,'check');
 
 # --BEHAVIOR-- initWidgets
Index: plugins/widgets/_define.php
===================================================================
--- plugins/widgets/_define.php	(revision 965)
+++ plugins/widgets/_define.php	(revision 665)
@@ -16,5 +16,5 @@
 	/* Description*/		"Widgets for your blog sidebars",
 	/* Author */			"Olivier Meunier & Dotclear Team",
-	/* Version */			'3.1',
+	/* Version */			'3',
 	array(
 		'permissions' =>	'admin',
Index: plugins/widgets/_public.php
===================================================================
--- plugins/widgets/_public.php	(revision 936)
+++ plugins/widgets/_public.php	(revision 671)
@@ -22,20 +22,13 @@
 	public static function tplWidgets($attr)
 	{
-		$type = isset($attr['type']) ? $attr['type'] : '';
-
+		$type = isset($attr['type']) ? $attr['type'] : 'nav';
+		
 		# widgets to disable
 		$disable = isset($attr['disable']) ? trim($attr['disable']) : '';
 		
-		if ($type == '') {
-			$res = "publicWidgets::widgetsHandler('nav','".addslashes($disable)."');"."\n".
-				"   publicWidgets::widgetsHandler('extra','".addslashes($disable)."');"."\n".
-				"   publicWidgets::widgetsHandler('custom','".addslashes($disable)."');"."\n";
-		} else {
-			if (!in_array($type, array('nav','extra','custom'))) {
-				$type = 'nav';
-			}
-			$res = "publicWidgets::widgetsHandler('".addslashes($type)."','".addslashes($disable)."');";
-		}
-		return '<?php '.$res.' ?>';
+		return
+		'<?php '.
+		"publicWidgets::widgetsHandler('".addslashes($type)."','".addslashes($disable)."'); ".
+		' ?>';
 	}
 	
Index: plugins/widgets/_widgets_functions.php
===================================================================
--- plugins/widgets/_widgets_functions.php	(revision 945)
+++ plugins/widgets/_widgets_functions.php	(revision 862)
@@ -18,13 +18,8 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
-			return;
-		}
-
 		$value = isset($GLOBALS['_search']) ? html::escapeHTML($GLOBALS['_search']) : '';
 		
 		return
-		'<div id="search"'.($w->class ? ' class="'.html::escapeHTML($w->class).'"' : '').'>'.
+		'<div id="search">'.
 		($w->title ? '<h2><label for="q">'.html::escapeHTML($w->title).'</label></h2>' : '').
 		'<form action="'.$core->blog->url.'" method="get">'.
@@ -41,11 +36,6 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
-			return;
-		}
-
-		$res =
-		'<div id="topnav"'.($w->class ? ' class="'.html::escapeHTML($w->class).'"' : '').'>'.
+		$res =
+		'<div id="topnav">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -72,9 +62,4 @@
 		global $core, $_ctx;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
-			return;
-		}
-
 		$rs = $core->blog->getCategories(array('post_type'=>'post'));
 		if ($rs->isEmpty()) {
@@ -83,5 +68,5 @@
 		
 		$res =
-		'<div class="categories'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="categories">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '');
 		
@@ -126,6 +111,5 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
+		if ($w->homeonly && $core->url->type != 'default') {
 			return;
 		}
@@ -144,5 +128,5 @@
 		
 		$res =
-		'<div class="selected'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="selected">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -161,6 +145,5 @@
 		global $core, $_ctx;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default' && $core->url->type != 'lang') ||
-			($w->homeonly == 2 && ($core->url->type == 'default' || $core->url->type == 'lang'))) {
+		if ($w->homeonly && $core->url->type != 'default' && $core->url->type != 'lang') {
 			return;
 		}
@@ -174,5 +157,5 @@
 		$langs = l10n::getISOcodes();
 		$res =
-		'<div class="langs'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="langs">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -202,6 +185,5 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
+		if ($w->homeonly && $core->url->type != 'default') {
 			return;
 		}
@@ -214,5 +196,5 @@
 		
 		$res =
-		'<div class="syndicate'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="syndicate">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -246,6 +228,5 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
+		if ($w->homeonly && $core->url->type != 'default') {
 			return;
 		}
@@ -263,5 +244,5 @@
 		
 		$res =
-		'<div class="feed'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="feed">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -297,11 +278,10 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
-			return;
-		}
-		
-		$res =
-		'<div class="text'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		if ($w->homeonly && $core->url->type != 'default') {
+			return;
+		}
+		
+		$res =
+		'<div class="text">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		$w->text.
@@ -315,6 +295,5 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
+		if ($w->homeonly && $core->url->type != 'default') {
 			return;
 		}
@@ -350,5 +329,5 @@
 		
 		$res =
-		'<div class="lastposts'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		'<div class="lastposts">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
@@ -368,6 +347,5 @@
 		global $core;
 		
-		if (($w->homeonly == 1 && $core->url->type != 'default') ||
-			($w->homeonly == 2 && $core->url->type == 'default')) {
+		if ($w->homeonly && $core->url->type != 'default') {
 			return;
 		}
@@ -381,5 +359,5 @@
 		}
 		
-		$res = '<div class="lastcomments'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+		$res = '<div class="lastcomments">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
Index: plugins/widgets/class.widgets.php
===================================================================
--- plugins/widgets/class.widgets.php	(revision 954)
+++ plugins/widgets/class.widgets.php	(revision 270)
@@ -36,7 +36,7 @@
 	}
 	
-	public function create($id,$name,$callback,$append_callback=null,$desc='')
-	{
-		$this->__widgets[$id] = new dcWidget($id,$name,$callback,$desc);
+	public function create($id,$name,$callback,$append_callback=null)
+	{
+		$this->__widgets[$id] = new dcWidget($id,$name,$callback);
 		$this->__widgets[$id]->append_callback = $append_callback;
 	}
@@ -135,5 +135,4 @@
 	private $id;
 	private $name;
-	private $desc;
 	private $public_callback = null;
 	public $append_callback = null;
@@ -149,10 +148,9 @@
 	}
 	
-	public function __construct($id,$name,$callback,$desc='')
+	public function __construct($id,$name,$callback)
 	{
 		$this->public_callback = $callback;
 		$this->id = $id;
 		$this->name = $name;
-		$this->desc = $desc;
 	}
 	
@@ -165,9 +163,4 @@
 	{
 		return $this->name;
-	}
-
-	public function desc()
-	{
-		return $this->desc;
 	}
 	
